package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.Menus;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.awt.*;
import java.util.List;
import java.util.Optional;

@Repository
public interface MenusRepository extends JpaRepository<Menus, Long> {

    List<Menus> findByIsDeleteFalse();
    Optional<Menus> findByIdAndIsDeleteFalse(Long id);

    @Query(value = "SELECT m " +
            "FROM Menus m " +
            "WHERE m.id in (SELECT DISTINCT(s.parentId) from Menus s " +
            "order by s.parentId) " +
            "AND m.isDelete = false")
    List<Menus> findAllParentMenu();


    @Query(value = "SELECT m " +
            "FROM Menus m " +
            "ORDER BY m.parentId, m.urutan")
    List<Menus> findAllOrderByParentAndUrutan();

    @Query(value = "SELECT m " +
            "FROM Menus m " +
            "WHERE m.isDelete = false " +
            "AND m.parentId != 0")
    List<Menus> findAllMenus();

}
