package com.iconplus.smartproc.service.rks;

import com.iconplus.smartproc.helper.model.Pagination;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.projection.RksDaftarIsiView;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.model.response.ListRksDaftarIsiResponse;
import com.iconplus.smartproc.model.response.RksDaftarIsiResponse;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class GetListRksDaftarIsiService implements BaseService<RksDaftarIsiRequest, ListRksDaftarIsiResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public GetListRksDaftarIsiService(RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Override
    public ListRksDaftarIsiResponse execute(RksDaftarIsiRequest input) {

        List<RksDaftarIsiResponse> rksDaftarIsiResponseList = new ArrayList<>();
        var rksDaftarIsiViews= rksDaftarIsiRepository.getListRksDaftarIsi(input.getPageable());
        for (RksDaftarIsiView rksDaftarIsiView : rksDaftarIsiViews) {
            RksDaftarIsiResponse rksDaftarIsiResponse = RksDaftarIsiResponse.builder()
                    .id(rksDaftarIsiView.getId())
                    .kodeTemplate(rksDaftarIsiView.getKodeTemplate())
                    .namaTemplate(rksDaftarIsiView.getNamaTemplate())
                    .metodePengadaanId(rksDaftarIsiView.getMetodePengadaanId())
                    .metodePengadaan(rksDaftarIsiView.getMetodePengadaan())
                    .versi(rksDaftarIsiView.getVersi())
                    .build();
            rksDaftarIsiResponseList.add(rksDaftarIsiResponse);
        }

        return ListRksDaftarIsiResponse.builder()
                .data(rksDaftarIsiResponseList)
                .pagination(Pagination.builder()
                        .pageSize(input.getPageable().getPageSize())
                        .currentPage(input.getPageable().getPageNumber())
                        .totalPages(rksDaftarIsiViews.getTotalPages())
                        .totalRecords(rksDaftarIsiViews.getTotalElements())
                        .isFirstPage(rksDaftarIsiViews.isFirst())
                        .isLastPage(rksDaftarIsiViews.isLast())
                        .build())
                .build();
    }
}
